-------------------------------------------------------------------------------
--	smallsystem ROM image (auto generated by rom_gen.pl)					 --
-------------------------------------------------------------------------------

library	ieee;
	use	ieee.std_logic_1164.all;
	use	ieee.std_logic_unsigned.all;
	use	ieee.std_logic_arith.all;

entity simplesystem_rom is
	port(
		reset			: in	std_logic;
		clk				: in	std_logic;
		sreset			: in	std_logic;
		rom_a			: in	std_logic_vector( 5 downto 0 );
		rom_oe			: in	std_logic;
		rom_q			: out	std_logic_vector( 15 downto 0 );
		rom_q_en		: out	std_logic
	);
end simplesystem_rom;

architecture rtl of simplesystem_rom is
	type rom_t is array( 0 to 63 ) of std_logic_vector( 15 downto 0 );
	constant rom_image : rom_t :=(
		X"4600", X"003C", X"0000", X"9E00", X"4600", X"F080", X"02FA", X"4640", 
		X"1000", X"0000", X"E408", X"4600", X"0003", X"0003", X"4640", X"1004", 
		X"0000", X"E408", X"A881", X"46C0", X"FFFF", X"0000", X"4640", X"3000", 
		X"0000", X"E288", X"9C01", X"47C0", X"0036", X"0000", X"4600", X"0009", 
		X"0000", X"4640", X"1006", X"0000", X"E008", X"9C01", X"8891", X"1293", 
		X"A091", X"4640", X"3000", X"0000", X"E288", X"1BC0", X"0000", X"0000", 
		X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", 
		X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000"
	);

	signal ff_q_en		: std_logic;
	signal ff_q			: std_logic_vector( 15 downto 0 );
begin

	-- output assignment
	rom_q		<= ff_q;
	rom_q_en	<= ff_q_en;

	-- flip flop
	process( reset, clk )
	begin
		if( reset = '1' )then
			ff_q_en		<= '0';
			ff_q		<= (others => '0');
		elsif( clk'event and clk = '1' )then
			if( sreset = '1' )then
				ff_q_en		<= '0';
				ff_q		<= (others => '0');
			else
				ff_q_en		<= rom_oe;
				if( rom_oe = '1' )then
					ff_q		<= rom_image( conv_integer( rom_a ) );
				else
					ff_q		<= (others => '0');
				end if;
			end if;
		end if;
	end process;
end rtl;
