-------------------------------------------------------------------------------
--	smallsystem ROM image (auto generated by rom_gen.pl)					 --
-------------------------------------------------------------------------------

library	ieee;
	use	ieee.std_logic_1164.all;
	use	ieee.std_logic_unsigned.all;
	use	ieee.std_logic_arith.all;

entity simplesystem_rom is
	port(
		reset			: in	std_logic;
		clk				: in	std_logic;
		sreset			: in	std_logic;
		rom_a			: in	std_logic_vector( 5 downto 0 );
		rom_oe			: in	std_logic;
		rom_q			: out	std_logic_vector( 15 downto 0 );
		rom_q_en		: out	std_logic
	);
end simplesystem_rom;

architecture rtl of simplesystem_rom is
	type rom_t is array( 0 to 63 ) of std_logic_vector( 15 downto 0 );
	constant rom_image : rom_t :=(
		X"4600", X"0100", X"0000", X"4640", X"0100", X"0000", X"4680", X"2000", 
		X"0000", X"4780", X"00FF", X"0000", X"E210", X"A8C0", X"E0C0", X"C100", 
		X"0323", X"4740", X"0048", X"0000", X"23E5", X"80D9", X"12DE", X"4740", 
		X"001C", X"0000", X"23DD", X"8001", X"8249", X"4740", X"0018", X"0000", 
		X"23CD", X"47C0", X"0042", X"0000", X"4600", X"BEEF", X"0000", X"E210", 
		X"47C0", X"0042", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", 
		X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", 
		X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000"
	);

	signal ff_q_en		: std_logic;
	signal ff_q			: std_logic_vector( 15 downto 0 );
begin

	-- output assignment
	rom_q		<= ff_q;
	rom_q_en	<= ff_q_en;

	-- flip flop
	process( reset, clk )
	begin
		if( reset = '1' )then
			ff_q_en		<= '0';
			ff_q		<= (others => '0');
		elsif( clk'event and clk = '1' )then
			if( sreset = '1' )then
				ff_q_en		<= '0';
				ff_q		<= (others => '0');
			else
				ff_q_en		<= rom_oe;
				if( rom_oe = '1' )then
					ff_q		<= rom_image( conv_integer( rom_a ) );
				else
					ff_q		<= (others => '0');
				end if;
			end if;
		end if;
	end process;
end rtl;
