-------------------------------------------------------------------------------
--	smallsystem top entity (auto generated by top_gen.pl)					 --
-------------------------------------------------------------------------------

library	ieee;
	use	ieee.std_logic_1164.all;
	use	ieee.std_logic_signed.all;
	use	ieee.std_logic_arith.all;

entity tb is
end tb;

architecture bhv of tb is
	component simplesystem_top
		port(
			reset			: in	std_logic;
			clk				: in	std_logic;
			sreset			: in	std_logic;
			seg7_seg7_out	: out	std_logic_vector( 27 downto 0 );
			pio_pio_in		: in	std_logic_vector( 15 downto 0 );
			pio_pio_out	: out	std_logic_vector( 15 downto 0 )
		);
	end component;

	signal reset			: std_logic := '1';
	signal clk				: std_logic := '0';
	signal sreset			: std_logic := '0';
	signal seg7_seg7_out	: std_logic_vector( 27 downto 0 );
	signal pio_pio_in		: std_logic_vector( 15 downto 0 );
	signal pio_pio_out	: std_logic_vector( 15 downto 0 );

	signal tb_end			: std_logic := '0';
begin

	-- ----------------------------------------------------- --
	--	target												 --
	-- ----------------------------------------------------- --
	u_target: simplesystem_top
	port map (
		reset			=> reset,
		clk				=> clk,
		sreset			=> sreset,
		seg7_seg7_out	 => seg7_seg7_out	,
		pio_pio_in		 => pio_pio_in		,
		pio_pio_out	 => pio_pio_out	
	);

	-- ----------------------------------------------------- --
	--	clock generator										 --
	-- ----------------------------------------------------- --
	process
	begin
		if( tb_end = '1' )then
			wait;
		end if;
		clk <= '0';
		wait for 5 ns;
		clk <= '1';
		wait for 5 ns;
	end process;

	-----------------------------------------------------------
	--	test bench											 --
	-----------------------------------------------------------
	process
	begin
		wait until( clk'event and clk = '1' );
		reset	<= '0';

		for i in 0 to 1000 loop
			wait until( clk'event and clk = '1' );
		end loop;
		tb_end <= '1';
		wait;
	end process;
end bhv;
