@echo off
set TOOL=..\..\tool
set SRC=..\..\src

echo assemble led_test
perl %TOOL%\small_asm.pl sram_test.asm

echo create rom device for sram_test
perl %TOOL%\rom_gen.pl sram_test.dmp

if not exist work (
	vlib work
)

echo create top entity
perl %TOOL%\top_gen.pl config.txt

echo compile
vcom %SRC%\cpu\cpu_top.vhd
vcom %SRC%\cpu\cpu_state.vhd
vcom %SRC%\cpu\cpu_register.vhd
vcom %SRC%\cpu\cpu_memory.vhd
vcom %SRC%\cpu\cpu_decoder.vhd
vcom %SRC%\pio\pio.vhd
vcom %SRC%\ram\ram.vhd
vcom %SRC%\timer\timer.vhd
vcom %SRC%\seg7\seg7.vhd
vcom %SRC%\sram\sram.vhd
vcom sram_test.vhd
vcom top.vhd
vcom tb.vhd

vsim -c -t ns tb -do all.do

pause
