-------------------------------------------------------------------------------
--	smallsystem ROM image (auto generated by rom_gen.pl)					 --
-------------------------------------------------------------------------------

library	ieee;
	use	ieee.std_logic_1164.all;
	use	ieee.std_logic_signed.all;
	use	ieee.std_logic_arith.all;

entity simplesystem_rom is
	port(
		nreset			: in	std_logic;
		clk				: in	std_logic;
		rom_a			: in	std_logic_vector( 4 downto 0 );
		rom_oe			: in	std_logic;
		rom_q			: out	std_logic_vector( 15 downto 0 );
		rom_q_en		: out	std_logic
	);
end simplesystem_rom;

architecture rtl of simplesystem_rom is
	type rom_t is array( 0 to 15 ) of std_logic_vector( 15 downto 0 );
	constant rom_image : rom_t :=(
		X"000A", X"6F6D", X"696A", X"6F6D", X"696A", X"0085", X"0C85", X"0C85", 
		X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000", X"0000"
	);

	signal ff_q_en		: std_logic;
	signal ff_q			: std_logic_vector( 15 downto 0 );
begin

	-- output assignment
	rom_q		<= ff_q;
	rom_q_en	<= ff_q_en;

	-- flip flop
	process( nreset, clk )
	begin
		if( nreset = '0' )then
			ff_q_en		<= '0';
			ff_q		<= (others => '0');
		elsif( clk'event and clk = '1' )then
			ff_q_en		<= rom_oe;
			if( rom_oe = '1' )then
				ff_q		<= rom_image( conv_integer( rom_a ) );
			else
				ff_q		<= (others => '0');
			end if;
		end if;
	end process;
end rtl;
